diff --git a/src/main/java/net/minecraft/core/block/entity/BlockEntity.java b/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
index 034d03dce..a3e142cc9 100644
--- a/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
@@ -1,29 +1,35 @@
 package net.minecraft.core.block.entity;
 
 import com.mojang.logging.LogUtils;
-import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.piston.MovingPistonBlockEntity;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.chunk.Chunk;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import java.util.HashMap;
 import java.util.Map;
+import java.util.Objects;
 
-// Referenced classes of package net.minecraft.src:
-//            NBTTagCompound, World, Block, FurnaceBlockEntity,
-//            ChestBlockEntity, JukeboxBlockEntity, DispenserBlockEntity, SignBlockEntity,
-//            MobSpawnerBlockEntity, NoteBlockEntity, TileEntityPiston
-
-public class BlockEntity
+public class BlockEntity implements ICarriable
 {
     private static final Logger LOGGER = LogUtils.getLogger();
 
     private static final Map<String, Class<? extends BlockEntity>> nameToClassMap = new HashMap<>();
     private static final Map<Class<? extends BlockEntity>, String> classToNameMap = new HashMap<>();
-    public World worldObj;
+    public @Nullable World worldObj; // Null when loading data from nbt and null when held by entity
+    public @Nullable CarriedBlock carriedBlock;
     public int x;
     public int y;
     public int z;
@@ -166,4 +172,148 @@ public class BlockEntity
         addMapping(FlowerJarBlockEntity.class, "FlowerJar");
         addMapping(GoldMeshBlockEntity.class, "MeshGold");
     }
+
+    @Override
+    public void heldTick(World world, Entity holder) {
+
+    }
+
+    public void dropContents(World world, int x, int y, int z) {
+
+    }
+
+    @Override
+    public boolean tryPlace(World world, Entity holder, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+        x = blockX + side.getOffsetX();
+        y = blockY + side.getOffsetY();
+        z = blockZ + side.getOffsetZ();
+
+        Block currentBlock = world.getBlock(x, y, z);
+        if (currentBlock != null && !currentBlock.hasTag(BlockTags.PLACE_OVERWRITES)) return false;
+        world.setBlockAndMetadataWithNotify(x, y, z, carriedBlock.block.id, carriedBlock.metadata);
+
+        worldObj = world;
+        this.carriedBlock = null;
+        this.validate();
+        world.removeBlockTileEntity(x, y, z);
+        world.setBlockTileEntity(x, y, z, this);
+        Block b = world.getBlock(x, y, z);
+        if (b != null && holder instanceof Mob) {
+            b.onBlockPlacedByMob(world, x, y, z, side, (Mob) holder, yPlaced);
+        }
+        return true;
+    }
+
+    @Override
+    public void drop(World world, Entity holder) {
+        final int holderX = MathHelper.floor(holder.x);
+        final int holderY = MathHelper.floor(holder.y);
+        final int holderZ = MathHelper.floor(holder.z);
+        for (int _y = holderY - 1; _y <= holderY + 1; _y++) {
+            for (int _x = holderX - 1; _x <= holderX + 1; _x++) {
+                for (int _z = holderZ - 1; _z <= holderZ + 1; _z++) {
+                    if (tryPlace(world, holder, _x, _y - 1, _z, Side.TOP, 0, 0)) {
+                        return;
+                    }
+                }
+            }
+        }
+        if (world.isClientSide) return;
+        dropContents(world, holderX, holderY, holderZ);
+        assert carriedBlock != null;
+        carriedBlock.block.dropBlockWithCause(world, EnumDropCause.WORLD, holderX, holderY, holderZ, carriedBlock.metadata, this, null); // TODO this might be scuffed since the position won't have correlated to a real block
+    }
+
+    @Override
+    public boolean canBeCarried(World world, Entity potentialHolder) {
+        return false;
+    }
+
+    @Override
+    public ICarriable pickup(World world, Entity holder) {
+        Block currentBlock = world.getBlock(x, y, z);
+        int currentMeta = world.getBlockMetadata(x, y, z);
+        world.removeBlockTileEntity(x, y, z);
+        Chunk c = world.getChunkFromBlockCoords(x, z);
+        c.setBlockIDRaw(x & 0b1111, y, z & 0b1111, 0);
+        c.recalcHeightmap();
+        world.notifyBlockChange(x, y, z, 0);
+        this.worldObj = null;
+        this.carriedBlock = getCarriedEntry(world, holder, currentBlock, currentMeta);
+        return carriedBlock;
+    }
+
+    public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
+        return new CarriedBlock(holder, currentBlock, currentMeta, this);
+    }
+
+    public static class CarriedBlock implements ICarriable {
+        // Ignore warnings, nbt read process *should* guarantee these to be non-null
+        public @NotNull Block block;
+        public int metadata;
+        public @NotNull BlockEntity entity;
+        public @NotNull Entity holder;
+        public @NotNull World world;
+        public CarriedBlock(@NotNull Entity holder, @NotNull Block block, int metadata, @NotNull BlockEntity entity) {
+            this.holder = holder;
+            this.block = block;
+            this.metadata = metadata;
+            this.entity = entity;
+            this.world = holder.world;
+        }
+
+        protected CarriedBlock() {
+
+        }
+
+        @Override
+        public void heldTick(World world, Entity holder) {
+            entity.heldTick(world, holder);
+        }
+
+        @Override
+        public boolean tryPlace(World world, Entity holder, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+            return entity.tryPlace(world, holder, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+        }
+
+        @Override
+        public void drop(World world, Entity holder) {
+            entity.drop(world, holder);
+        }
+
+        @Override
+        public boolean canBeCarried(World world, Entity potentialHolder) {
+            return entity.canBeCarried(world, potentialHolder);
+        }
+
+        @Override
+        public ICarriable pickup(World world, Entity holder) {
+            return entity.pickup(world, holder);
+        }
+
+        @Override
+        public void writeToNBT(CompoundTag tag) {
+            CompoundTag entityTag = new CompoundTag();
+            entity.writeToNBT(entityTag);
+            tag.put("entity", entityTag);
+            tag.putInt("block", block.id);
+            tag.putShort("meta", (short) metadata);
+            tag.putString("type", "blockEntity");
+        }
+
+        @Override
+        public void readFromNBT(CompoundTag tag) {
+            entity = createAndLoadEntity(tag.getCompound("entity"));
+            entity.carriedBlock = this;
+            block = Objects.requireNonNull(Block.getBlock(tag.getInteger("block")));
+            metadata = tag.getShort("meta");
+        }
+
+        public static CarriedBlock createAndLoadCarriedBlock(@NotNull Entity holder, CompoundTag tag) {
+            CarriedBlock carriedBlock = new CarriedBlock();
+            carriedBlock.holder = holder;
+            carriedBlock.readFromNBT(tag);
+            return carriedBlock;
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/ChestBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/ChestBlockEntity.java
index f6f7dbd4c..a9b147df7 100644
--- a/src/main/java/net/minecraft/core/block/entity/ChestBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/ChestBlockEntity.java
@@ -5,16 +5,25 @@ package net.minecraft.core.block.entity;
 //            BlockEntity, IInventory, ItemStack, NBTTagCompound,
 //            NBTTagList, World, Player
 
+import com.mojang.logging.LogUtils;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.ChestBlock;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 import net.minecraft.core.player.inventory.InventorySorter;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.World;
+import org.slf4j.Logger;
 
 public class ChestBlockEntity extends BlockEntity
     implements Container
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
 
     public ChestBlockEntity()
     {
@@ -132,5 +141,29 @@ public class ChestBlockEntity extends BlockEntity
         InventorySorter.sortInventory(chestContents);
     }
 
+    @Override
+    public void dropContents(World world, int x, int y, int z) {
+        super.dropContents(world, x, y, z);
+        for(int i = 0; i < this.getContainerSize(); i++) {
+            ItemStack itemStack = this.getItem(i);
+            if(itemStack == null) continue;
+            ItemEntity item = world.dropItem(x, y, z, itemStack);
+            item.xd *= 0.5;
+            item.yd *= 0.5;
+            item.zd *= 0.5;
+            item.pickupDelay = 0;
+        }
+    }
+
+    @Override
+    public boolean canBeCarried(World world, Entity potentialHolder) {
+        return true;
+    }
+
+    @Override
+    public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
+        return super.getCarriedEntry(world, holder, currentBlock, ChestBlock.getMetaWithDirection(ChestBlock.getMetaWithType(currentMeta, ChestBlock.Type.SINGLE), Direction.NORTH));
+    }
+
     private ItemStack[] chestContents;
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java
index 02643c2c7..63a328024 100644
--- a/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/DispenserBlockEntity.java
@@ -1,11 +1,15 @@
 package net.minecraft.core.block.entity;
 
+import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.IDispensable;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
+import net.minecraft.core.world.World;
 
 import java.util.Random;
 
@@ -20,7 +24,7 @@ public class DispenserBlockEntity extends BlockEntity
     public DispenserBlockEntity()
     {
         dispenserContents = new ItemStack[9];
-        dispenserRandom = new Random();
+        random = new Random();
     }
 
     @Override
@@ -66,7 +70,7 @@ public class DispenserBlockEntity extends BlockEntity
         int j = 1;
         for(int k = 0; k < dispenserContents.length; k++)
         {
-            if(dispenserContents[k] != null && dispenserRandom.nextInt(j++) == 0)
+            if(dispenserContents[k] != null && random.nextInt(j++) == 0)
             {
                 i = k;
             }
@@ -166,6 +170,47 @@ public class DispenserBlockEntity extends BlockEntity
         // Do nothing
     }
 
+    @Override
+    public void dropContents(World world, int x, int y, int z) {
+        super.dropContents(world, x, y, z);
+        label0:
+        for (int l = 0; l < this.getContainerSize(); l++) {
+            ItemStack itemstack = this.getItem(l);
+            if (itemstack == null) {
+                continue;
+            }
+            float f = random.nextFloat() * 0.8F + 0.1F;
+            float f1 = random.nextFloat() * 0.8F + 0.1F;
+            float f2 = random.nextFloat() * 0.8F + 0.1F;
+            do {
+                if (itemstack.stackSize <= 0) {
+                    continue label0;
+                }
+                int i1 = random.nextInt(21) + 10;
+                if (i1 > itemstack.stackSize) {
+                    i1 = itemstack.stackSize;
+                }
+                itemstack.stackSize -= i1;
+                ItemEntity entityitem = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+                float f3 = 0.05F;
+                entityitem.xd = (float) random.nextGaussian() * f3;
+                entityitem.yd = (float) random.nextGaussian() * f3 + 0.2F;
+                entityitem.zd = (float) random.nextGaussian() * f3;
+                world.entityJoinedWorld(entityitem);
+            } while (true);
+        }
+    }
+
+    @Override
+    public boolean canBeCarried(World world, Entity potentialHolder) {
+        return true;
+    }
+
+    @Override
+    public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
+        return super.getCarriedEntry(world, holder, currentBlock, (currentMeta & ~0b111) | 0b010 /*Reset rotation, primarily to make it render in hand properly*/);
+    }
+
     private ItemStack dispenserContents[];
-    private Random dispenserRandom;
+    private final Random random;
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/FlagBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/FlagBlockEntity.java
index 1736888d0..9dbd9fd2c 100644
--- a/src/main/java/net/minecraft/core/block/entity/FlagBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/FlagBlockEntity.java
@@ -6,6 +6,7 @@ import java.util.UUID;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 
+import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
@@ -13,6 +14,7 @@ import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.BlockEntityDataPacket;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.UUIDHelper;
+import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
 public class FlagBlockEntity extends BlockEntity
diff --git a/src/main/java/net/minecraft/core/block/entity/FlowerJarBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/FlowerJarBlockEntity.java
index 32f4af1cc..c94621a16 100644
--- a/src/main/java/net/minecraft/core/block/entity/FlowerJarBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/FlowerJarBlockEntity.java
@@ -1,8 +1,13 @@
 package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.BlockEntityDataPacket;
+import net.minecraft.core.world.World;
 
 public class FlowerJarBlockEntity extends BlockEntity {
 
@@ -22,8 +27,20 @@ public class FlowerJarBlockEntity extends BlockEntity {
         }
     }
 
+    @Override
+    public void dropContents(World world, int x, int y, int z) {
+        super.dropContents(world, x, y, z);
+        if (flowerInPot > 0 && Block.hasTag(flowerInPot, BlockTags.PLANTABLE_IN_JAR)) {
+            flowerInPot = 0;
+            if (!world.isClientSide) {
+                world.dropItem(x, y, z, new ItemStack(flowerInPot, 1, 0));
+            }
+        }
+    }
+
     @Override
     public Packet getDescriptionPacket() {
         return new BlockEntityDataPacket(this);
     }
+
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
index c2aac8276..92f4f32d4 100644
--- a/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
@@ -8,24 +8,32 @@ package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.FurnaceBlock;
 import net.minecraft.core.crafting.LookupFuelFurnace;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryFurnace;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
 
 import java.util.List;
+import java.util.Random;
 
 public class FurnaceBlockEntity extends BlockEntity
         implements Container
 {
+    private final Random random;
 
     public FurnaceBlockEntity()
     {
+        random = new Random();
         furnaceItemStacks = new ItemStack[3];
         currentBurnTime = 0;
         maxBurnTime = 0;
@@ -54,7 +62,7 @@ public class FurnaceBlockEntity extends BlockEntity
             {
                 ItemStack itemstack = furnaceItemStacks[index];
                 furnaceItemStacks[index] = null;
-                if (index == 2) {
+                if (worldObj != null && index == 2) {
                     worldObj.markBlockNeedsUpdate(x, y, z);
                 }
                 return itemstack;
@@ -63,7 +71,7 @@ public class FurnaceBlockEntity extends BlockEntity
             if(furnaceItemStacks[index].stackSize <= 0)
             {
                 furnaceItemStacks[index] = null;
-                if (index == 2) {
+                if (worldObj != null && index == 2) {
                     worldObj.markBlockNeedsUpdate(x, y, z);
                 }
             }
@@ -82,7 +90,7 @@ public class FurnaceBlockEntity extends BlockEntity
         {
             itemstack.stackSize = getMaxStackSize();
         }
-        if (index == 2 && itemstack == null) {
+        if (worldObj != null && index == 2 && itemstack == null) {
             worldObj.markBlockNeedsUpdate(x, y, z);
         }
     }
@@ -171,14 +179,14 @@ public class FurnaceBlockEntity extends BlockEntity
         {
             currentBurnTime--;
         }
-        if(worldObj != null && !worldObj.isClientSide)
+        if(worldObj == null || !worldObj.isClientSide)
         {
-        	if(worldObj.getBlockId(x, y, z) == Blocks.FURNACE_STONE_IDLE.id) {
+        	if(worldObj == null || worldObj.getBlockId(x, y, z) == Blocks.FURNACE_STONE_IDLE.id) {
             	if(currentBurnTime == 0 && furnaceItemStacks[0] == null) {
             		if(furnaceItemStacks[1] != null && furnaceItemStacks[1].itemID == Blocks.NETHERRACK.id) {
             			furnaceItemStacks[1].stackSize--;
             			if(furnaceItemStacks[1].stackSize <= 0) furnaceItemStacks[1] = null;
-            			FurnaceBlock.updateFurnaceBlockState(true, worldObj, x, y, z);
+            			updateFurnace();
             			furnaceUpdated = true;
             		}
             	}
@@ -294,13 +302,17 @@ public class FurnaceBlockEntity extends BlockEntity
         {
             furnaceItemStacks[0] = null;
         }
-        if (wasEmpty && furnaceItemStacks[2] != null) {
+        if (worldObj != null && wasEmpty && furnaceItemStacks[2] != null) {
             worldObj.markBlockNeedsUpdate(x, y, z);
         }
     }
 
     protected void updateFurnace(){
-        FurnaceBlock.updateFurnaceBlockState(currentBurnTime > 0, worldObj, x, y, z);
+        if (worldObj != null) {
+            FurnaceBlock.updateFurnaceBlockState(currentBurnTime > 0, worldObj, x, y, z);
+        } else if (carriedBlock != null) {
+            carriedBlock.block = currentBurnTime > 0 ? Blocks.FURNACE_STONE_ACTIVE : Blocks.FURNACE_STONE_IDLE;
+        }
     }
 
     private int getBurnTimeFromItem(ItemStack itemStack)
@@ -320,11 +332,75 @@ public class FurnaceBlockEntity extends BlockEntity
         return entityplayer.distanceToSqr((double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D) <= 64D;
     }
 
+    @Override
+    public void dropContents(World world, int x, int y, int z) {
+        super.dropContents(world, x, y, z);
+        if(!FurnaceBlock.keepFurnaceInventory)
+        {
+            label0:
+            for(int l = 0; l < this.getContainerSize(); l++)
+            {
+                ItemStack itemstack = this.getItem(l);
+                if(itemstack == null)
+                {
+                    continue;
+                }
+                float f = random.nextFloat() * 0.8F + 0.1F;
+                float f1 = random.nextFloat() * 0.8F + 0.1F;
+                float f2 = random.nextFloat() * 0.8F + 0.1F;
+                do
+                {
+                    if(itemstack.stackSize <= 0)
+                    {
+                        continue label0;
+                    }
+                    int i1 = random.nextInt(21) + 10;
+                    if(i1 > itemstack.stackSize)
+                    {
+                        i1 = itemstack.stackSize;
+                    }
+                    itemstack.stackSize -= i1;
+                    ItemEntity itemEntity = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+                    float f3 = 0.05F;
+                    itemEntity.xd = (float)random.nextGaussian() * f3;
+                    itemEntity.yd = (float)random.nextGaussian() * f3 + 0.2F;
+                    itemEntity.zd = (float)random.nextGaussian() * f3;
+                    world.entityJoinedWorld(itemEntity);
+                } while(true);
+            }
+
+        }
+    }
+
     @Override
     public void sortContainer() {
         // Do nothing
     }
 
+    @Override
+    public void heldTick(World world, Entity holder) {
+        tick();
+    }
+
+    @Override
+    public boolean tryPlace(World world, Entity holder, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+        boolean success = super.tryPlace(world, holder, blockX, blockY, blockZ, side, xPlaced, yPlaced);
+        if (success) {
+            updateFurnace();
+        }
+        return success;
+    }
+
+    @Override
+    public boolean canBeCarried(World world, Entity potentialHolder) {
+        return true;
+    }
+
+    @Override
+    public CarriedBlock getCarriedEntry(World world, Entity holder, Block currentBlock, int currentMeta) {
+        return super.getCarriedEntry(world, holder, currentBlock, (currentMeta & ~0b111) | 0b010 /*Reset rotation, primarily to make it render in hand properly*/);
+    }
+
     protected ItemStack[] furnaceItemStacks;
     public int maxBurnTime;
     public int currentCookTime;
diff --git a/src/main/java/net/minecraft/core/block/entity/GoldMeshBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/GoldMeshBlockEntity.java
index 16c673589..6a4366a6f 100644
--- a/src/main/java/net/minecraft/core/block/entity/GoldMeshBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/GoldMeshBlockEntity.java
@@ -1,10 +1,12 @@
 package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.BlockEntityDataPacket;
+import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
 public class GoldMeshBlockEntity extends BlockEntity {
@@ -62,4 +64,16 @@ public class GoldMeshBlockEntity extends BlockEntity {
     public Packet getDescriptionPacket() {
         return new BlockEntityDataPacket(this);
     }
+
+    @Override
+    public void dropContents(World world, int x, int y, int z) {
+        super.dropContents(world, x, y, z);
+        if (filterItem != null){
+            ItemEntity item = world.dropItem(x, y, z, filterItem);
+            item.xd *= 0.5;
+            item.yd *= 0.5;
+            item.zd *= 0.5;
+            item.pickupDelay = 0;
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java
index a0265330f..819537f2b 100644
--- a/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java
@@ -5,6 +5,10 @@ package net.minecraft.core.block.entity;
 //            BlockEntity, NBTTagCompound
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.save.conversion.ChunkConverter;
 import com.mojang.nbt.CompoundTag;
 
@@ -38,5 +42,24 @@ public class JukeboxBlockEntity extends BlockEntity {
         }
     }
 
+    @Override
+    public void dropContents(World world, int x, int y, int z) {
+        if (record != 0) {
+            world.playSoundEffect(1005, x, y, z, 0);
+            world.playRecord(null, null, x, y, z);
+            record = 0;
+            setChanged();
+            world.setBlockMetadataWithNotify(x, y, z, 0);
+            int i1 = record;
+            float f = 0.7F;
+            double d = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
+            double d1 = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.2D + 0.6D;
+            double d2 = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
+            ItemEntity entityitem = new ItemEntity(world, (double) x + d, (double) y + d1, (double) z + d2, new ItemStack(i1, 1, 0));
+            entityitem.pickupDelay = 10;
+            world.entityJoinedWorld(entityitem);
+        }
+    }
+
     public int record;
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/MobSpawnerBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/MobSpawnerBlockEntity.java
index 8383010e4..26be181a2 100644
--- a/src/main/java/net/minecraft/core/block/entity/MobSpawnerBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/MobSpawnerBlockEntity.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block.entity;
 
 import com.mojang.logging.LogUtils;
+import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.MobCategory;
@@ -10,6 +11,7 @@ import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.SetMobSpawnerPacket;
 import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.world.World;
 import org.slf4j.Logger;
 
 import java.util.List;
@@ -192,4 +194,5 @@ public class MobSpawnerBlockEntity extends BlockEntity
         tag.putString("EntityId", mobId != null ? mobId : "none");
         tag.putShort("Delay", (short)delay);
     }
+
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
index 8ca0bac10..e221f94e3 100644
--- a/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
@@ -6,6 +6,7 @@ package net.minecraft.core.block.entity;
 
 import net.minecraft.core.block.material.Material;
 import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.entity.Entity;
 import net.minecraft.core.world.World;
 
 public class NoteBlockEntity extends BlockEntity
@@ -74,4 +75,5 @@ public class NoteBlockEntity extends BlockEntity
 
     public byte note;
     public boolean previousRedstoneState;
+
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java
index 7a0463c87..7d7e15ea0 100644
--- a/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java
@@ -3,6 +3,7 @@ package net.minecraft.core.block.entity;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.world.IVehicle;
+import net.minecraft.core.world.World;
 
 public class SeatBlockEntity
     extends BlockEntity
@@ -87,4 +88,5 @@ public class SeatBlockEntity
     public float getXRotDelta() {
         return 0;
     }
+
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/SignBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/SignBlockEntity.java
index f34335af4..85cbf6a68 100644
--- a/src/main/java/net/minecraft/core/block/entity/SignBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/SignBlockEntity.java
@@ -1,12 +1,14 @@
 package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.BlockEntityDataPacket;
 import net.minecraft.core.util.helper.UUIDHelper;
+import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.UUID;
@@ -125,4 +127,5 @@ public class SignBlockEntity extends BlockEntity
     {
         return new BlockEntityDataPacket(this);
     }
+
 }
